<?php
/**
 * Clase Base DP para BaseCrTelefonoTipoDP
 *
 * @package    
 * @subpackage BaseCrTelefonoTipoDP
 * @author     Willy
 * @version    SVN:: BaseCrTelefonoTipoDP.class.php,v 1.1 2014-10-30 10:20:41 william.taype Exp $
 */
abstract class BaseCrTelefonoTipoDP extends CrTelefonoTipoBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrTelefonoTipoBN )
    {
      $o_CrTelefonoTipoBN = $bSetDefault;
      if($o_CrTelefonoTipoBN->getIdTipoTelefono()) : $this->setIdTipoTelefono($o_CrTelefonoTipoBN->getIdTipoTelefono()); endif;
      if($o_CrTelefonoTipoBN->getDescripcion()) : $this->setDescripcion($o_CrTelefonoTipoBN->getDescripcion()); endif;
      if($o_CrTelefonoTipoBN->getEstado()) : $this->setEstado($o_CrTelefonoTipoBN->getEstado()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdTipoTelefono),(MAX(IdTipoTelefono)+1), 1) AS Maximo FROM cr_telefono_tipo;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdTipoTelefono($row[0]);

      if($this->getIdTipoTelefono()){
        $a_Fields = array();

        if($this->getIdTipoTelefono()) : $a_Fields['IdTipoTelefono'] = ($this->getIdTipoTelefono()); endif;
        if($this->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getDescripcion()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_telefono_tipo (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdTipoTelefono())
      {
        $a_Fields = array();

        if($this->getIdTipoTelefono()) : $a_Fields['IdTipoTelefono'] = ($this->getIdTipoTelefono()); endif;
        if($this->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getDescripcion()); endif;
        if($this->getEstado()) : $a_Fields['Estado'] = ($this->getEstado()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_telefono_tipo SET ".$sStringField." WHERE 1 AND IdTipoTelefono='".$this->getIdTipoTelefono()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdTipoTelefono())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_telefono_tipo WHERE 1 AND IdTipoTelefono='".$this->getIdTipoTelefono()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdTipoTelefono)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdTipoTelefono, Descripcion, Estado FROM cr_telefono_tipo WHERE 1 AND IdTipoTelefono='".$vIdTipoTelefono."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrTelefonoTipoDP = new CrTelefonoTipoDP();
    $o_CrTelefonoTipoDP->setIdTipoTelefono($o_propel->IdTipoTelefono);
    $o_CrTelefonoTipoDP->setDescripcion($o_propel->Descripcion);
    $o_CrTelefonoTipoDP->setEstado($o_propel->Estado);
    return $o_CrTelefonoTipoDP;
  }
}